#!/bin/sh

bin="/opt/ctsim/bin/"

# Generate phantom image

${bin}phm2sdf sample-phm.sdf 256 256 --nsample 2
${bin}sdf2img sample-phm.sdf sample-phm.png --format png

# Simulate CT data collection and generate raysum sinugram for display
${bin}phm2rs  sample-rs.rs 367 320 --nray 2 
${bin}rs2sdf  sample-rs.rs sample-rs.sdf
${bin}sdf2img sample-rs.sdf sample-rs.png --format png

# Reconstruct raysums and generate image for display
${bin}ctrec   sample-rs.rs sample-rec.sdf 256 256 
${bin}sdf2img sample-rec.sdf sample-rec.png --format png

# Files sample-phm.png, sample-rs.png, and sample-rec.png are ready for display
